-- ExtraStaticPS
-- Specialization for extra static PS

local mod_directory = g_currentModDirectory;
source(Utils.getFilename("scripts/StaticParticleSystem.lua", mod_directory));

ExtraStaticPS = {};

function ExtraStaticPS.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Combine, specializations);
end;

function ExtraStaticPS:load(xmlFile)
		
	self.staticParticleSystems = {};
	local entry = {};
	entry.ps = {};
	--Utils.loadParticleSystem(xmlFile, entry.ps, "vehicle.staticGroundParticleSystem", self.components, false, nil, self.baseDirectory);
	StaticParticleSystem.loadParticleSystem(xmlFile, entry.ps, "vehicle.staticStrawParticleSystem", self.components, false, nil, self.baseDirectory);			
	if table.getn(entry.ps) > 0 then
		entry.isActive = false;
		table.insert(self.staticParticleSystems, entry);
	end
	local i=0;
	while true do
		local baseName = string.format("vehicle.staticStrawParticleSystems.strawParticleSystem(%d)", i);
		if not hasXMLProperty(xmlFile, baseName) then
			break;
		end;
		local entry = {};
		entry.ps = {};
		--Utils.loadParticleSystem(xmlFile, entry.ps, baseName, self.components, false, nil, self.baseDirectory);
		StaticParticleSystem.loadParticleSystem(xmlFile, entry.ps, baseName, self.components, false, nil, self.baseDirectory);			
		if table.getn(entry.ps) > 0 then
			entry.isActive = false;
			entry.cuttingArea = i+1;
			table.insert(self.staticParticleSystems, entry);
		end
		i = i+1;
	end;	
	
end;

function ExtraStaticPS:delete()
	for _, entry in ipairs(self.staticParticleSystems) do
		Utils.deleteParticleSystem(entry.ps);
		entry.isActive = false;
	end;
end;

function ExtraStaticPS:mouseEvent(posX, posY, isDown, isUp, button)
end;

function ExtraStaticPS:keyEvent(unicode, sym, modifier, isDown)
end;

function ExtraStaticPS:update(dt)
end;

function ExtraStaticPS:updateTick(dt)
	
	if self.isClient then
		if self:getIsActive() then
			if self.lastValidFillType == Fillable.FILLTYPE_WHEAT or self.lastValidFillType == Fillable.FILLTYPE_BARLEY then
				if self.strawPSenabled or self.chopperPSenabled then
					for i,e in pairs(self.staticParticleSystems) do
						Utils.setEmittingState(e.ps, true);
					end;
				else
					for i,e in pairs(self.staticParticleSystems) do
						Utils.setEmittingState(e.ps, false);
					end;
				end;
			else
				for i,e in pairs(self.staticParticleSystems) do
					Utils.setEmittingState(e.ps, false);
				end;
			end;
		else
			for i,e in pairs(self.staticParticleSystems) do
				Utils.setEmittingState(e.ps, false);
			end;
		end;
	end;
	
end;

function ExtraStaticPS:draw()
end;